#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#define INCL_DOSPROCESS
#define INCL_WIN
#define INCL_DOS
#include <os2.h>

#include "tvplugin.h"

PLCALLS Pl;

BOOL Inited = FALSE;

#define VERSION "LifeviewFly98/AverTVPhone98/PixelView/WinFast  FM-tuner plugin; 1 feb 2000;"

#define ABSENT		(-1)


#define TSA552x_CB_MSB          (0x80) //  ࢠ - ᥣ 窠
#define TSA552x_CB_CP           (1<<6)	/* set this for fast tuning */
#define TSA552x_CB_T2           (1<<5)	/* test mode - Normally set to 0 */
#define TSA552x_CB_T1           (1<<4)	/* test mode - Normally set to 0 */
#define TSA552x_CB_T0           (1<<3)	/*  test mode - Normally set to 1 */
#define TSA552x_CB_RSA          (1<<2)	/* 0 for 31.25 khz, 1 for 62.5 kHz */
#define TSA552x_CB_RSB          (1<<1)	/* 0 for FM 50kHz steps, 1 = Use RSA*/
#define TSA552x_CB_OS           (1<<0)	/* Set to 0 for normal operation */

#define TSA552x_RADIO           (TSA552x_CB_MSB |       \
                                 TSA552x_CB_T0)

#define TSA552x_P7              (1<<7) //  1 0 1 0
#define TSA552x_P6              (1<<6)	//  1 0 1 0
#define TSA552x_P5              (1<<5)	//  1 0 0 1
#define TSA552x_P4              (1<<4)	//  0 0 1 1
#define TSA552x_P3              (1<<3) //
#define TSA552x_P2              (1<<2)	//  . . . . - 1
#define TSA552x_P1              (1<<1)	//
#define TSA552x_P0              (1)	   //


#define TSCH5_RADIO             0x86

ULONG i2c_addr=0;
int			N;
unsigned char			control;
unsigned char			band, band0;

int q=0;

BOOL tuner=1;

UCHAR conti=0xA5;

NPipe *pipe;
BOOL mute=0, unmute=0;;

FILE *debu;

/*********************************************************************\
*
*                       SetFreq
*
\*********************************************************************/
int SetFreq(double frequency)
{
		if(frequency<6000) frequency=6000;
		if(frequency>90000) frequency=90000;
		
		N = (frequency + 1070)/5;

  FILE *out=fopen("fly98fm.log", "a");
  
  if(!fexist("alps")){
    		control = TSA552x_RADIO;
    		
    		band    = (TSA552x_P7 | TSA552x_P5 | TSA552x_P2 | TSA552x_P1); 
    		
    		/*
    		if(frequency >= 16825){
    		   band=(TSA552x_P7 | TSA552x_P4 | TSA552x_P2); 
    		}
    		if(frequency >= 44725){
    		   band=(TSA552x_P5 | TSA552x_P4 | TSA552x_P2); 
    		}
    		*/
    		
    		if(mute){ 
         fprintf(out, "mute\n");
    		   band = band | TSA552x_P3;
    		   mute=0;
    		}   
    		else{
         fprintf(out, "unmute\n");
    		}
    		
  }
  else{
    		control = TSCH5_RADIO;
	    	band    = 0x04;
  }


  (*Pl.I2CW)(i2c_addr,  control, band,           1);
  (*Pl.I2CW)(i2c_addr,  (N>>8) & 0x7f, N & 0xff, 1);
					
  fprintf(out, "New frequency: %.2f\n", frequency/100);
  //fprintf(out, "band: 0x%x\n", band);
  fclose(out);

  	
		return 0;
}



/*********************************************************************\
*
*                       ⠭
*
\*********************************************************************/

LONG InitStructures()
{
	
  for (ULONG addr = 0xCE; addr >= 0xC0; addr-=2)
    if ((*Pl.I2CT)(addr))
      i2c_addr = addr;

  FILE *out=fopen("fly98fm.log", "w+");
  fprintf(out, "%s\n", VERSION);
  fprintf(out, "Address: 0x%x\n", i2c_addr);
  //fprintf(out, "Control byte: 0x%x\n", conti);
  fclose(out);

  //SetFreq(10050);

  return (0);

}


void _Optlink Search(void *p)
{

   DATETIME dt;
   char time[128];

   ULONG q;
   CHAR *f;
   APIRET rc;
   int i;
   BOOL innocent;
   ULONG Delay=1000;
   ULONG WriteDelay=0;
   ULONG bytesres;
   CoolFMPacket *pack;
   CoolFMPacket pack2={0,0};

   innocent=TRUE;

   debu=fopen("pipe.log", "w+");
   
   while (1) {
      if (innocent) {
         pipe->FirstConnect();
         innocent=FALSE;
      }
      else {
         rc=pipe->PipeRead(&bytesres);

         if ((!rc)&&(bytesres>0)) {
            printf(">\n");

            int q=bytesres/sizeof(CoolFMPacket);
            pack=(CoolFMPacket *)pipe->buf;
            for (i=0; i<q; i++) {
               switch(pack[i].Command){
                  case 0:
                     printf("PIPE: CooLFM on-line\n");
                     fprintf(debu, "CooLFM on-line\n");
                     break;
                  case 2:
                     mute=0;
                     // pack[i].freq   
                     SetFreq(100*(pack[i].freq));
                     break;
                     
                     /*
                  case 3:
                     mute=0;
                     SetFreq(100*pack[i].freq);
                     break;
                     */
                  case 4:
                     mute=1;
                     //(*Pl.SwitchMute)(1);
                     SetFreq(100*(pack[i].freq));
                     break;

               }

            }



         }
      }
      pipe->PipeWrite(&pack2);

      fflush(debu);
      DosSleep(1000);
   }

   fclose(debu);

   /*
        DosGetDateTime(&dt);
      sprintf(time,"%02d%02d%02d",
         dt.hours,dt.minutes,dt.seconds);

      SetFreq(i);
      in=fopen("haco8.log","a");
      fprintf(in, "%s) %d\n", time, i);
      fclose(in);
      DosSleep(1000);
      */

}


/*********************************************************************\
*
*                       PLINIT
*
\*********************************************************************/
TV_EXTERN APIRET PLINIT (PLCALLS *calls, HWND hwnd, ULONG version)
{
   memcpy(&Pl, calls, sizeof(PLCALLS));

   InitStructures();

   pipe=new NPipe("\\PIPE\\BROOKTREE");
   _beginthread(Search,NULL,32768,NULL);

   Inited=TRUE;

   return 0;
}

/*********************************************************************\
*
*                       PLDONE
*
\*********************************************************************/
TV_EXTERN APIRET PLDONE ()
{
   return 0;
}


/*********************************************************************\
*
*                       PLPRESS
*
\*********************************************************************/
TV_EXTERN APIRET PLPRESS (char key, char skey)
{
   char newfreq[129];
   char controlbyte[129];

   if(Inited && (key=='F' || key=='f')){
      FILE *in=fopen("freq", "r");
      fgets(newfreq, 128, in);
      //fgets(controlbyte, 128, in);
      fclose(in);

      //conti=atoi(controlbyte);
      mute=0;
      SetFreq(100*atof(newfreq));
   }

   return 0;
}


BOOL fexist(char *filename) {
  if(!filename) return 0;
  FILESTATUS3 f;
  return !DosQueryPathInfo(filename, FIL_STANDARD, &f, sizeof(FILESTATUS3)) && !(f.attrFile & FILE_DIRECTORY);
}
