#define INCL_PM
#define INCL_WIN
#define INCL_GPI
#define INCL_OS2MM
#define INCL_DOS
#define INCL_BASE
#include <os2.h>

#include "npipes.hpp"

#define waiting 0
#define working 1

CoolFMPacket pack;

NPipe::SCreate(CHAR *pn, HPIPE *pph)
{
  rc= DosCreateNPipe(pn,
                        pph,
                        NP_ACCESS_DUPLEX,
                        NP_NOWAIT|NP_TYPE_BYTE|NP_READMODE_BYTE|0x01,
                        4096,
                        4096,
                        0);
  fprintf(debu, "DosCreateNPipe [%d]\n",rc);
  return rc;
}

NPipe::SConnect(HPIPE *pph)
{
  rc=DosConnectNPipe(*pph);
  fprintf(debu, "DosConnectNPipe [%d]\n",rc);
  return rc;

}

APIRET NPipe::COpen(CHAR *pn, HPIPE *pph)
{
  ULONG Action;

  // ᮥ塞,  .
  rc=DosOpen(pn,
                 pph,
                 &Action,
                 0,
                 FILE_NORMAL,
                 OPEN_ACTION_FAIL_IF_NEW|OPEN_ACTION_OPEN_IF_EXISTS,
                 OPEN_ACCESS_READWRITE|OPEN_SHARE_DENYNONE,
                 0);

  fprintf(debu, "DosOpen [%d]\n",rc);
  return rc;
}



APIRET NPipe::PipeRead(ULONG *pbytesres)
{
  *pbytesres=0;

  return DosRead(ph,buf,1024,pbytesres);
}


APIRET NPipe::DisConnect(void)
{
  if(Server) rc=DosDisConnectNPipe(ph);
  else rc=DosClose(ph);

  fprintf(debu, "disconnect %d\n",rc);
  return rc;
}

APIRET NPipe::Connect(void)
{
  if(Server) {
    rc=SConnect(&ph);
    fprintf(debu, "SConnect %d\n",rc);
  }
  else innocent=TRUE;

  return rc;
}



void NPipe::PipeWrite(CoolFMPacket* pack)
{
  ULONG bytessent;

  rc=DosWrite(ph,pack,sizeof(structCoolFMPacket),&bytessent);
  fprintf(debu, "᫠: %d\n",bytessent);
  
  if(rc!=0 && mode){
    mode=waiting;
    DisConnect();
    
    if(Server) {
       rc=SConnect(&ph);
       fprintf(debu, "SConnect %d\n",rc);
    }
    else{
       // ⥯   ࢥ஬! !
       SCreate(pipename,&ph);
       SConnect(&ph);
       Server=TRUE;     // -
       fprintf(debu, "몫\n");
    
    }
    //(*pChangeConStatus)(myid,0);    
    return;
  }
  
  if(rc==0) {
    mode=working;
    //(*pChangeConStatus)(myid,1);    
  }  
  
  return;
}


NPipe::FirstConnect()
{
  rc=COpen(pipename,&ph);
  if(rc!=0){
    SCreate(pipename,&ph);
    SConnect(&ph);
    Server=TRUE;    
    //(*pChangeConStatus)(myid, 0);    
  }
  else{
    Server=0;
    mode=working;
    fprintf(debu, "\n");

    CoolFMPacket pack={0,0};
    PipeWrite(&pack);
    //(*pChangeConStatus)(myid,1);    
    //PipeWrite('?',0);
  }
}


NPipe::NPipe(char *newpipename)
{
  //pChangeConStatus=npipe->ChangeConStatus;
  strncpy(pipename,newpipename,127);
  //myid=npipe->id;
}


NPipe::~NPipe()
{
  //PipeWrite("");
  DisConnect();
}
