/***************************************************************/
/*                                                             */
/*                                                             */
/***************************************************************/

#define INCL_WIN
#define INCL_GPI
#define INCL_DOSPROCESS

#include <os2.h>
#include <stdlib.h>
#include <stdio.h>

#include "tvplugin.h"
#include "cragra.hpp"

HWND hWndHappy;
HBITMAP hbmGrabbed;
HPS hps;
HAB hab;
RECTL rtl;
POINTL ptl;
SWP swp;

HBITMAP ScreenRectl2Bitmap()
{
  HDC hdcMem;
  PSZ pszData[4]={"Display",NULL,NULL,NULL};
  HPS hpsMem, hps;
  SIZEL sizlPage={0,0};
  BITMAPINFOHEADER2 bmp;
  PBITMAPINFO2 pbmi;
  SHORT sWidth=rtl.xRight-rtl.xLeft;
  SHORT sHeight=rtl.yTop-rtl.yBottom;
  POINTL aptl[4];
  LONG alData[2];
  HBITMAP hbm;

  // Create the memory device context and presentation space so they
  // are compatible with the screen device context and presentation space.

  hdcMem = DevOpenDC(hab, OD_MEMORY, "*", 4,
      (PDEVOPENDATA) pszData, NULLHANDLE);


  hpsMem = GpiCreatePS(hab, hdcMem, &sizlPage,
    PU_PELS | GPIA_ASSOC | GPIT_MICRO);

  /* Determine the device's plane/bit-count format. */

  GpiQueryDeviceBitmapFormats(hpsMem, 2, alData);

  // Load the BITMAPINFOHEADER2 and BITMAPINFO2 structures. The sWidth and
  // sHeight fields specify the width and height of the destination
  // rectangle.
  pbmi=(PBITMAPINFO2)new BITMAPINFO2;

  pbmi->cbFix         = bmp.cbFix         = (ULONG) sizeof(BITMAPINFOHEADER2);
  pbmi->cx            = bmp.cx            = sWidth;
  pbmi->cy            = bmp.cy            = sHeight;
  pbmi->cPlanes       = bmp.cPlanes       = alData[0];
  pbmi->cBitCount     = bmp.cBitCount     = alData[1];
  pbmi->ulCompression = bmp.ulCompression = BCA_UNCOMP;
  bmp.cbImage = (((sWidth *
      (1 << bmp.cPlanes) * (1 << bmp.cBitCount)) + 31) / 32) * sHeight;
  pbmi->cbImage = ((sWidth+31)/32) * sHeight;

  pbmi->cxResolution    = bmp.cxResolution    = 70;
  pbmi->cyResolution    = bmp.cyResolution    = 70;
  pbmi->cclrUsed        = bmp.cclrUsed        = 2;
  pbmi->cclrImportant   = bmp.cclrImportant   = 0;
  pbmi->usUnits         = bmp.usUnits         = BRU_METRIC;
  pbmi->usReserved      = bmp.usReserved      = 0;
  pbmi->usRecording     = bmp.usRecording     = BRA_BOTTOMUP;
  pbmi->usRendering     = bmp.usRendering     = BRH_NOTHALFTONED;
  pbmi->cSize1          = bmp.cSize1          = 0;
  pbmi->cSize2          = bmp.cSize2          = 0;
  pbmi->ulColorEncoding = bmp.ulColorEncoding = BCE_RGB;
  pbmi->ulIdentifier    = bmp.ulIdentifier    = 0;

  /* Create a bit map that is compatible with the display.            */

  hbm = GpiCreateBitmap(hpsMem, &bmp, FALSE, NULL, pbmi);
  // if(!hbm)WinMessageBox(HWND_DESKTOP,HWND_DESKTOP,"suxx","Message Box",0,MB_ICONHAND|MB_OK);

  /* Associate the bit map and the memory presentation space.         */

  GpiSetBitmap(hpsMem, hbm);

  /* Copy the screen to the bit map.                                  */

  aptl[0].x = 0;       /* Lower-left corner of destination rectangle  */
  aptl[0].y = 0;       /* Lower-left corner of destination rectangle  */
  aptl[1].x = sWidth;  /* Upper-right corner of destination rectangle */
  aptl[1].y = sHeight; /* Upper-right corner of destination rectangle */

  aptl[2].x = rtl.xLeft+ptl.x;   
  aptl[2].y = rtl.yBottom+ptl.y; 
  aptl[3].x = rtl.xRight; 
  aptl[3].y = rtl.yTop;   


  hps = WinGetScreenPS(HWND_DESKTOP);

  GpiBitBlt(hpsMem, hps,
      sizeof(aptl) / sizeof(POINTL), /* Number of points in aptl      */
      aptl, ROP_SRCCOPY, BBO_IGNORE);

  WinReleasePS(hps);

  return hbm;
}



TV_EXTERN APIRET PLINIT (PLCALLS *calls, HWND hwnd, ULONG version) 
{

  hab = WinInitialize(0);
  
  hWndHappy=hwnd;
  
  return 0;

}


TV_EXTERN APIRET PLDONE () 
{

  return 0;

}


TV_EXTERN APIRET PLPRESS (char key, char skey) 
{
 
  // ஢ઠ, ந樠஢ ?
  
  
  ptl.x=0; ptl.y=0;
  WinMapWindowPoints(hWndHappy,HWND_DESKTOP,&ptl,1);
  
  WinQueryWindowRect(hWndHappy, &rtl);
  
  hbmGrabbed=ScreenRectl2Bitmap();
  
  //*
  //*  㥬 १
  //*
  
  rtl.xLeft=300; rtl.yBottom=300; 
  hps=WinGetScreenPS(HWND_DESKTOP);
  
  WinDrawBitmap(hps,
                hbmGrabbed,         
                NULL,             
                (PPOINTL)&rtl,
                0L,               
                0L,               
                DBM_NORMAL);      
  
  WinReleasePS(hps);
  
  
  return 0;

}

